#include <dlfcn.h>
#include <stdio.h>

int
main(int argc, char *argv[])
{
	void *handle;
	char **bar, *(*foo)();

	handle = dlopen(argv[1], RTLD_LAZY);
	if (handle == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		return (1);
	}
	bar = dlsym(handle, "bar");
	foo = dlsym(handle, "foo");

	printf("PTR: &foo is %p: bar is %p\n", foo, bar);
	fflush(stdout);
	printf("STR: foo is %s\n", foo());
	printf("STR: bar is %s\n", *bar);

	dlclose(handle);
	return (0);
}
